﻿package {
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.display.*;
	import flash.filters.*;
	import flash.geom.*;

	public class Curver extends Sprite {
		private var j:Number;
		private var k:Number;
		private var i:Number=0;
		private var nb:Number=4;
		private var inc:Number;

		private var moveX:Number;
		private var moveY:Number;


		private var drawer:Sprite;
		private var data:BitmapData;
		private var background:Bitmap;

		private var bmp:Bitmap;
		private var blur:BlurFilter;
		private var rate:Number=.92;//this will make our effect fade to black
		private var colorMatrix:ColorMatrixFilter;
		private var pntOrigin=new Point(0,0);
		private var rect:Rectangle;



		public function Curver() {
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		}

		private function addedHandler(e:Event):void {
			data=new BitmapData(stage.stageWidth,stage.stageHeight,false,0x000000);
			background=new Bitmap(data);
			addChild(background);
			drawer = new Sprite();

			blur=new BlurFilter(3,3,9);
			rect=new Rectangle(0,0,stage.stageWidth,stage.stageHeight);

			colorMatrix = new ColorMatrixFilter([
			   rate,0,0,0,0,
			   0,rate,0,0,0,
			   0,0,rate,0,0,
			   0,0,0,rate,0
			]);

			addEventListener(Event.ENTER_FRAME, enterHandler);

			moveX=stage.stageWidth/2;
			moveY=stage.stageHeight/2;

		}

		private function enterHandler(e:Event):void {
			drawer.graphics.clear();

			if (i<1) {
				j=stage.stageWidth/5;
				k=stage.stageHeight/5;
			}

			if (moveX <= 0) {
				moveX=0;
			} else if (moveX >=stage.stageWidth){
				moveX=stage.stageWidth;
			}
			
			if (moveY <= 0) {
				moveY=0;
			} else if (moveY >=stage.stageHeight){
				moveY=stage.stageHeight;
			}


			for (var element = 1; element < nb; element++) {

				drawer.graphics.lineStyle(element,0xFF8500,.3, true);
				inc = (.1-(element/(12)));
				
				i+=inc;

				j += i * (Math.sin(i));
				k += i * (Math.cos(i));

				if (i%400==0) {
					//i=i;
					inc*=-1;
					
				}

				moveX += (mouseX-stage.stageWidth/2)/200;
				moveY += (mouseY-stage.stageHeight/2)/200;
				//trace(moveX);

				//drawer.graphics.drawEllipse(stage.stageWidth/2-j/2,stage.stageHeight/2-k/2,j,k);
				drawer.graphics.drawEllipse(moveX-j/2,moveY-k/2,j+(element*3),k+(element*3));
				//trace(i);


			}


			data.draw(drawer);

			//data.applyFilter(data,rect,pntOrigin,blur);
			data.applyFilter(data,rect,pntOrigin,colorMatrix);

			bmp=new Bitmap(data);

			stage.addChildAt(bmp,0);

			if (stage.numChildren>100) {
				stage.removeChildAt(1);
			}
		}
	}
}